gtk-0.12.5.0: Binding to the Gtk+ graphical user interface library.

Portability | portable (depends on GHC)
Stability | provisional
Maintainer | gtk2hs-users@lists.sourceforge.net
Safe Haskell | None

Graphics.UI.Gtk.Misc.HandleBox

Contents

- Detail
- Class Hierarchy
- Types
- Constructors
- Methods
- Attributes
- Signals

Description

a widget for detachable window portions

Synopsis

- data HandleBox
- class BinClass o => HandleBoxClass o
- castToHandleBox :: GObjectClass obj => obj -> HandleBox
- gTypeHandleBox :: GType
- toHandleBox :: HandleBoxClass o => o -> HandleBox
- handleBoxNew :: IO HandleBox
- data ShadowType
  - = ShadowNone
  - | ShadowIn
  - | ShadowOut
  - | ShadowEtchedIn
  - | ShadowEtchedOut
- handleBoxSetShadowType :: HandleBoxClass self => self -> ShadowType -> IO ()
- handleBoxGetShadowType :: HandleBoxClass self => self -> IO ShadowType
- data PositionType
  - = PosLeft
  - | PosRight
  - | PosTop
  - | PosBottom
- handleBoxSetHandlePosition :: HandleBoxClass self => self -> PositionType -> IO ()
- handleBoxGetHandlePosition :: HandleBoxClass self => self -> IO PositionType
- handleBoxSetSnapEdge :: HandleBoxClass self => self -> PositionType -> IO ()
- handleBoxGetSnapEdge :: HandleBoxClass self => self -> IO PositionType
- handleBoxShadowType :: HandleBoxClass self => Attr self ShadowType
- handleBoxHandlePosition :: HandleBoxClass self => Attr self PositionType
- handleBoxSnapEdge :: HandleBoxClass self => Attr self PositionType
- handleBoxSnapEdgeSet :: HandleBoxClass self => Attr self Bool
- onChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)
- afterChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)
- onChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)
- afterChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)

# Detail

The `HandleBox` widget allows a portion of a window to be "torn off". It is a bin widget which displays its child and a handle that the user can drag to tear off a separate window (the float window) containing the child widget. A thin ghost is drawn in the original location of the handlebox. By dragging the separate window back to its original location, it can be reattached.

When reattaching, the ghost and float window, must be aligned along one of the edges, the snap edge. This either can be specified by the application programmer explicitely, or Gtk+ will pick a reasonable default based on the handle position.

To make detaching and reattaching the handlebox as minimally confusing as possible to the user, it is important to set the snap edge so that the snap edge does not move when the handlebox is deattached. For instance, if the handlebox is packed at the bottom of a VBox, then when the handlebox is detached, the bottom edge of the handlebox's allocation will remain fixed as the height of the handlebox shrinks, so the snap edge should be set to `PosBottom`.

# Class Hierarchy

     | GObject
     | +----Object
     | +----Widget
     | +----Container
     | +----Bin
     | +----HandleBox

# Types

data HandleBox

Instances

Eq HandleBox |
Ord HandleBox |
GObjectClass HandleBox |
HandleBoxClass HandleBox |
BinClass HandleBox |
ContainerClass HandleBox |
WidgetClass HandleBox |
ObjectClass HandleBox |

class BinClass o => HandleBoxClass o

Instances

HandleBoxClass HandleBox |

castToHandleBox :: GObjectClass obj => obj -> HandleBox

gTypeHandleBox :: GType

toHandleBox :: HandleBoxClass o => o -> HandleBox

# Constructors

handleBoxNew :: IO HandleBox

Create a new handle box.

# Methods

data ShadowType

Shadow types

Constructors

ShadowNone |
ShadowIn |
ShadowOut |
ShadowEtchedIn |
ShadowEtchedOut |

Instances

Enum ShadowType |
Eq ShadowType |
Show ShadowType |

handleBoxSetShadowType :: HandleBoxClass self => self -> ShadowType -> IO ()

Sets the type of shadow to be drawn around the border of the handle box.

handleBoxGetShadowType

Arguments

:: HandleBoxClass self |
=> self |
-> IO ShadowType | returns the type of shadow currently drawn around the handle box.

Gets the type of shadow drawn around the handle box. See `handleBoxSetShadowType`.

data PositionType

Position a scale's value is drawn relative to the trough

Constructors

PosLeft |
PosRight |
PosTop |
PosBottom |

Instances

Enum PositionType |
Eq PositionType |
Show PositionType |

handleBoxSetHandlePosition

Arguments

:: HandleBoxClass self |
=> self |
-> PositionType | `position` - the side of the handlebox where the handle should be drawn.
-> IO () |

Sets the side of the handlebox where the handle is drawn.

handleBoxGetHandlePosition

Arguments

:: HandleBoxClass self |
=> self |
-> IO PositionType | returns the current handle position.

Gets the handle position of the handle box. See `handleBoxSetHandlePosition`.

handleBoxSetSnapEdge :: HandleBoxClass self => self -> PositionType -> IO ()

Sets the snap edge of the HandleBox. The snap edge is the edge of the detached child that must be aligned with the corresponding edge of the "ghost" left behind when the child was detached to reattach the torn-off window. Usually, the snap edge should be chosen so that it stays in the same place on the screen when the handlebox is torn off.

If the snap edge is not set, then an appropriate value will be guessed from the handle position. If the handle position is `PosRight` or `PosLeft`, then the snap edge will be `PosTop`, otherwise it will be `PosLeft`.

handleBoxGetSnapEdge :: HandleBoxClass self => self -> IO PositionType

Gets the edge used for determining reattachment of the handle box. See `handleBoxSetSnapEdge`.

# Attributes

handleBoxShadowType :: HandleBoxClass self => Attr self ShadowType

Appearance of the shadow that surrounds the container.

Default value: `ShadowEtchedOut`

handleBoxHandlePosition :: HandleBoxClass self => Attr self PositionType

Position of the handle relative to the child widget.

Default value: `PosLeft`

handleBoxSnapEdge :: HandleBoxClass self => Attr self PositionType

Side of the handlebox that's lined up with the docking point to dock the handlebox.

Default value: `PosTop`

handleBoxSnapEdgeSet :: HandleBoxClass self => Attr self Bool

Whether to use the value from the snap_edge property or a value derived from handle_position.

Default value: `False`

# Signals

onChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)

This signal is emitted when the contents of the handlebox are reattached to the main window.

afterChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)

This signal is emitted when the contents of the handlebox are reattached to the main window.

onChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)

This signal is emitted when the contents of the handlebox are detached from the main window.

afterChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)

This signal is emitted when the contents of the handlebox are detached from the main window.